/* BackgroundUtils.c generated by valac 0.56.17, the Vala compiler
 * generated from BackgroundUtils.vala, do not modify */

/*
 * Copyright 2024 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-2.0-or-later
 */
/*
 *   The method for calculating the background information and the classes that are
 *   related to it are copied from Gala.DBus.
 */

#include <glib.h>
#include <float.h>
#include <math.h>
#include <clutter/clutter.h>
#include <glib-object.h>
#include <string.h>
#include <gio/gio.h>
#include <meta/meta-plugin.h>
#include <meta/meta-background-actor.h>
#include <meta/meta-background-group.h>
#include <meta/display.h>
#include <stdlib.h>
#include <cogl/cogl.h>

#define GREETER_COMPOSITOR_BACKGROUND_UTILS_SATURATION_WEIGHT 1.5
#define GREETER_COMPOSITOR_BACKGROUND_UTILS_WEIGHT_THRESHOLD 1.0
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GREETER_COMPOSITOR_BACKGROUND_UTILS_TYPE_DUMMY_OFFSCREEN_EFFECT (greeter_compositor_background_utils_dummy_offscreen_effect_get_type ())
#define GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_COMPOSITOR_BACKGROUND_UTILS_TYPE_DUMMY_OFFSCREEN_EFFECT, GreeterCompositorBackgroundUtilsDummyOffscreenEffect))
#define GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_COMPOSITOR_BACKGROUND_UTILS_TYPE_DUMMY_OFFSCREEN_EFFECT, GreeterCompositorBackgroundUtilsDummyOffscreenEffectClass))
#define GREETER_COMPOSITOR_BACKGROUND_UTILS_IS_DUMMY_OFFSCREEN_EFFECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_COMPOSITOR_BACKGROUND_UTILS_TYPE_DUMMY_OFFSCREEN_EFFECT))
#define GREETER_COMPOSITOR_BACKGROUND_UTILS_IS_DUMMY_OFFSCREEN_EFFECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_COMPOSITOR_BACKGROUND_UTILS_TYPE_DUMMY_OFFSCREEN_EFFECT))
#define GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_COMPOSITOR_BACKGROUND_UTILS_TYPE_DUMMY_OFFSCREEN_EFFECT, GreeterCompositorBackgroundUtilsDummyOffscreenEffectClass))

typedef struct _GreeterCompositorBackgroundUtilsDummyOffscreenEffect GreeterCompositorBackgroundUtilsDummyOffscreenEffect;
typedef struct _GreeterCompositorBackgroundUtilsDummyOffscreenEffectClass GreeterCompositorBackgroundUtilsDummyOffscreenEffectClass;
typedef struct _GreeterCompositorBackgroundUtilsDummyOffscreenEffectPrivate GreeterCompositorBackgroundUtilsDummyOffscreenEffectPrivate;
enum  {
	GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT_0_PROPERTY,
	GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT_NUM_PROPERTIES
};
static GParamSpec* greeter_compositor_background_utils_dummy_offscreen_effect_properties[GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT_NUM_PROPERTIES];
enum  {
	GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT_DONE_PAINTING_SIGNAL,
	GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT_NUM_SIGNALS
};
static guint greeter_compositor_background_utils_dummy_offscreen_effect_signals[GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT_NUM_SIGNALS] = {0};

#define GREETER_COMPOSITOR_BACKGROUND_UTILS_TYPE_COLOR_INFORMATION (greeter_compositor_background_utils_color_information_get_type ())
typedef struct _GreeterCompositorBackgroundUtilsColorInformation GreeterCompositorBackgroundUtilsColorInformation;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER (greeter_compositor_window_manager_get_type ())
#define GREETER_COMPOSITOR_WINDOW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER, GreeterCompositorWindowManager))
#define GREETER_COMPOSITOR_WINDOW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER, GreeterCompositorWindowManagerClass))
#define GREETER_COMPOSITOR_IS_WINDOW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER))
#define GREETER_COMPOSITOR_IS_WINDOW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER))
#define GREETER_COMPOSITOR_WINDOW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_COMPOSITOR_TYPE_WINDOW_MANAGER, GreeterCompositorWindowManagerClass))

typedef struct _GreeterCompositorWindowManager GreeterCompositorWindowManager;
typedef struct _GreeterCompositorWindowManagerClass GreeterCompositorWindowManagerClass;
typedef struct _Block16Data Block16Data;

#define GREETER_COMPOSITOR_TYPE_BACKGROUND_MANAGER (greeter_compositor_background_manager_get_type ())
#define GREETER_COMPOSITOR_BACKGROUND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GREETER_COMPOSITOR_TYPE_BACKGROUND_MANAGER, GreeterCompositorBackgroundManager))
#define GREETER_COMPOSITOR_BACKGROUND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GREETER_COMPOSITOR_TYPE_BACKGROUND_MANAGER, GreeterCompositorBackgroundManagerClass))
#define GREETER_COMPOSITOR_IS_BACKGROUND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GREETER_COMPOSITOR_TYPE_BACKGROUND_MANAGER))
#define GREETER_COMPOSITOR_IS_BACKGROUND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GREETER_COMPOSITOR_TYPE_BACKGROUND_MANAGER))
#define GREETER_COMPOSITOR_BACKGROUND_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GREETER_COMPOSITOR_TYPE_BACKGROUND_MANAGER, GreeterCompositorBackgroundManagerClass))

typedef struct _GreeterCompositorBackgroundManager GreeterCompositorBackgroundManager;
typedef struct _GreeterCompositorBackgroundManagerClass GreeterCompositorBackgroundManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _GreeterCompositorBackgroundUtilsGetBackgroundColorInformationData GreeterCompositorBackgroundUtilsGetBackgroundColorInformationData;

struct _GreeterCompositorBackgroundUtilsDummyOffscreenEffect {
	ClutterOffscreenEffect parent_instance;
	GreeterCompositorBackgroundUtilsDummyOffscreenEffectPrivate * priv;
};

struct _GreeterCompositorBackgroundUtilsDummyOffscreenEffectClass {
	ClutterOffscreenEffectClass parent_class;
};

struct _GreeterCompositorBackgroundUtilsColorInformation {
	gdouble average_red;
	gdouble average_green;
	gdouble average_blue;
	gdouble mean_luminance;
	gdouble luminance_variance;
	gdouble mean_acutance;
};

struct _Block16Data {
	int _ref_count_;
	GreeterCompositorBackgroundUtilsDummyOffscreenEffect* effect;
	MetaBackgroundActor* newest_background_actor;
	gint x_start;
	gint y_start;
	gint width;
	gint height;
	gdouble mean_acutance;
	gdouble variance;
	gdouble mean;
	gdouble r_total;
	gdouble g_total;
	gdouble b_total;
	gulong paint_signal_handler;
	gpointer _async_data_;
};

struct _GreeterCompositorBackgroundUtilsGetBackgroundColorInformationData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GreeterCompositorWindowManager* wm;
	gint reference_x;
	gint reference_y;
	gint reference_width;
	gint reference_height;
	GreeterCompositorBackgroundUtilsColorInformation result;
	Block16Data* _data16_;
	GreeterCompositorBackgroundManager* bg_manager;
	MetaBackgroundGroup* _tmp0_;
	MetaBackgroundGroup* _tmp1_;
	MetaDisplay* _tmp2_;
	ClutterActor* _tmp3_;
	GreeterCompositorBackgroundManager* _tmp4_;
	GreeterCompositorBackgroundManager* _tmp5_;
	MetaDisplay* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GError* _tmp9_;
	GError* _tmp10_;
	GreeterCompositorBackgroundUtilsDummyOffscreenEffect* _tmp11_;
	GreeterCompositorBackgroundManager* _tmp12_;
	MetaBackgroundActor* _tmp13_;
	MetaBackgroundActor* _tmp14_;
	MetaBackgroundActor* _tmp15_;
	GreeterCompositorBackgroundUtilsDummyOffscreenEffect* _tmp16_;
	gint bg_actor_width;
	MetaBackgroundActor* _tmp17_;
	gfloat _tmp18_;
	gfloat _tmp19_;
	gint bg_actor_height;
	MetaBackgroundActor* _tmp20_;
	gfloat _tmp21_;
	gfloat _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GError* _tmp28_;
	GError* _tmp29_;
	GreeterCompositorBackgroundUtilsDummyOffscreenEffect* _tmp30_;
	gulong _tmp31_;
	MetaBackgroundActor* _tmp32_;
	GreeterCompositorBackgroundUtilsColorInformation _tmp33_;
	GError* _inner_error0_;
};

static gpointer greeter_compositor_background_utils_dummy_offscreen_effect_parent_class = NULL;

VALA_EXTERN GType greeter_compositor_background_utils_dummy_offscreen_effect_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterCompositorBackgroundUtilsDummyOffscreenEffect, g_object_unref)
static void greeter_compositor_background_utils_dummy_offscreen_effect_real_post_paint (ClutterEffect* base,
                                                                                 ClutterPaintNode* node,
                                                                                 ClutterPaintContext* context);
static gboolean __lambda38_ (GreeterCompositorBackgroundUtilsDummyOffscreenEffect* self);
static gboolean ___lambda38__gsource_func (gpointer self);
VALA_EXTERN GreeterCompositorBackgroundUtilsDummyOffscreenEffect* greeter_compositor_background_utils_dummy_offscreen_effect_new (void);
VALA_EXTERN GreeterCompositorBackgroundUtilsDummyOffscreenEffect* greeter_compositor_background_utils_dummy_offscreen_effect_construct (GType object_type);
static GType greeter_compositor_background_utils_dummy_offscreen_effect_get_type_once (void);
VALA_EXTERN GType greeter_compositor_background_utils_color_information_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GreeterCompositorBackgroundUtilsColorInformation* greeter_compositor_background_utils_color_information_dup (const GreeterCompositorBackgroundUtilsColorInformation* self);
VALA_EXTERN void greeter_compositor_background_utils_color_information_free (GreeterCompositorBackgroundUtilsColorInformation* self);
static void greeter_compositor_background_utils_get_background_color_information_data_free (gpointer _data);
VALA_EXTERN GType greeter_compositor_window_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterCompositorWindowManager, g_object_unref)
VALA_EXTERN void greeter_compositor_background_utils_get_background_color_information (GreeterCompositorWindowManager* wm,
                                                                           gint reference_x,
                                                                           gint reference_y,
                                                                           gint reference_width,
                                                                           gint reference_height,
                                                                           GAsyncReadyCallback _callback_,
                                                                           gpointer _user_data_);
VALA_EXTERN void greeter_compositor_background_utils_get_background_color_information_finish (GAsyncResult* _res_,
                                                                                  GreeterCompositorBackgroundUtilsColorInformation* result,
                                                                                  GError** error);
static gboolean greeter_compositor_background_utils_get_background_color_information_co (GreeterCompositorBackgroundUtilsGetBackgroundColorInformationData* _data_);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
VALA_EXTERN GType greeter_compositor_background_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GreeterCompositorBackgroundManager, g_object_unref)
VALA_EXTERN MetaBackgroundGroup* greeter_compositor_window_manager_get_background_group (GreeterCompositorWindowManager* self);
VALA_EXTERN MetaBackgroundActor* greeter_compositor_background_manager_get_newest_background_actor (GreeterCompositorBackgroundManager* self);
static void __lambda39_ (Block16Data* _data16_);
static void ___lambda39__greeter_compositor_background_utils_dummy_offscreen_effect_done_painting (GreeterCompositorBackgroundUtilsDummyOffscreenEffect* _sender,
                                                                                            gpointer self);

static gboolean
__lambda38_ (GreeterCompositorBackgroundUtilsDummyOffscreenEffect* self)
{
	gboolean result;
#line 20 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_signal_emit (self, greeter_compositor_background_utils_dummy_offscreen_effect_signals[GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT_DONE_PAINTING_SIGNAL], 0);
#line 21 "../compositor/WingpanelManager/BackgroundUtils.vala"
	result = FALSE;
#line 21 "../compositor/WingpanelManager/BackgroundUtils.vala"
	return result;
#line 233 "BackgroundUtils.c"
}

static gboolean
___lambda38__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda38_ ((GreeterCompositorBackgroundUtilsDummyOffscreenEffect*) self);
#line 19 "../compositor/WingpanelManager/BackgroundUtils.vala"
	return result;
#line 243 "BackgroundUtils.c"
}

static void
greeter_compositor_background_utils_dummy_offscreen_effect_real_post_paint (ClutterEffect* base,
                                                                            ClutterPaintNode* node,
                                                                            ClutterPaintContext* context)
{
	GreeterCompositorBackgroundUtilsDummyOffscreenEffect * self;
#line 17 "../compositor/WingpanelManager/BackgroundUtils.vala"
	self = (GreeterCompositorBackgroundUtilsDummyOffscreenEffect*) base;
#line 17 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_return_if_fail (node != NULL);
#line 17 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_return_if_fail (context != NULL);
#line 18 "../compositor/WingpanelManager/BackgroundUtils.vala"
	CLUTTER_EFFECT_CLASS (greeter_compositor_background_utils_dummy_offscreen_effect_parent_class)->post_paint ((ClutterEffect*) G_TYPE_CHECK_INSTANCE_CAST (self, clutter_offscreen_effect_get_type (), ClutterOffscreenEffect), node, context);
#line 19 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda38__gsource_func, g_object_ref (self), g_object_unref);
#line 262 "BackgroundUtils.c"
}

GreeterCompositorBackgroundUtilsDummyOffscreenEffect*
greeter_compositor_background_utils_dummy_offscreen_effect_construct (GType object_type)
{
	GreeterCompositorBackgroundUtilsDummyOffscreenEffect * self = NULL;
#line 15 "../compositor/WingpanelManager/BackgroundUtils.vala"
	self = (GreeterCompositorBackgroundUtilsDummyOffscreenEffect*) g_object_new (object_type, NULL);
#line 15 "../compositor/WingpanelManager/BackgroundUtils.vala"
	return self;
#line 273 "BackgroundUtils.c"
}

GreeterCompositorBackgroundUtilsDummyOffscreenEffect*
greeter_compositor_background_utils_dummy_offscreen_effect_new (void)
{
#line 15 "../compositor/WingpanelManager/BackgroundUtils.vala"
	return greeter_compositor_background_utils_dummy_offscreen_effect_construct (GREETER_COMPOSITOR_BACKGROUND_UTILS_TYPE_DUMMY_OFFSCREEN_EFFECT);
#line 281 "BackgroundUtils.c"
}

static void
greeter_compositor_background_utils_dummy_offscreen_effect_class_init (GreeterCompositorBackgroundUtilsDummyOffscreenEffectClass * klass,
                                                                       gpointer klass_data)
{
#line 15 "../compositor/WingpanelManager/BackgroundUtils.vala"
	greeter_compositor_background_utils_dummy_offscreen_effect_parent_class = g_type_class_peek_parent (klass);
#line 15 "../compositor/WingpanelManager/BackgroundUtils.vala"
	((ClutterEffectClass *) klass)->post_paint = (void (*) (ClutterEffect*, ClutterPaintNode*, ClutterPaintContext*)) greeter_compositor_background_utils_dummy_offscreen_effect_real_post_paint;
#line 15 "../compositor/WingpanelManager/BackgroundUtils.vala"
	greeter_compositor_background_utils_dummy_offscreen_effect_signals[GREETER_COMPOSITOR_BACKGROUND_UTILS_DUMMY_OFFSCREEN_EFFECT_DONE_PAINTING_SIGNAL] = g_signal_new ("done-painting", GREETER_COMPOSITOR_BACKGROUND_UTILS_TYPE_DUMMY_OFFSCREEN_EFFECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 294 "BackgroundUtils.c"
}

static void
greeter_compositor_background_utils_dummy_offscreen_effect_instance_init (GreeterCompositorBackgroundUtilsDummyOffscreenEffect * self,
                                                                          gpointer klass)
{
}

static GType
greeter_compositor_background_utils_dummy_offscreen_effect_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GreeterCompositorBackgroundUtilsDummyOffscreenEffectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) greeter_compositor_background_utils_dummy_offscreen_effect_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GreeterCompositorBackgroundUtilsDummyOffscreenEffect), 0, (GInstanceInitFunc) greeter_compositor_background_utils_dummy_offscreen_effect_instance_init, NULL };
	GType greeter_compositor_background_utils_dummy_offscreen_effect_type_id;
	greeter_compositor_background_utils_dummy_offscreen_effect_type_id = g_type_register_static (clutter_offscreen_effect_get_type (), "GreeterCompositorBackgroundUtilsDummyOffscreenEffect", &g_define_type_info, 0);
	return greeter_compositor_background_utils_dummy_offscreen_effect_type_id;
}

GType
greeter_compositor_background_utils_dummy_offscreen_effect_get_type (void)
{
	static volatile gsize greeter_compositor_background_utils_dummy_offscreen_effect_type_id__once = 0;
	if (g_once_init_enter (&greeter_compositor_background_utils_dummy_offscreen_effect_type_id__once)) {
		GType greeter_compositor_background_utils_dummy_offscreen_effect_type_id;
		greeter_compositor_background_utils_dummy_offscreen_effect_type_id = greeter_compositor_background_utils_dummy_offscreen_effect_get_type_once ();
		g_once_init_leave (&greeter_compositor_background_utils_dummy_offscreen_effect_type_id__once, greeter_compositor_background_utils_dummy_offscreen_effect_type_id);
	}
	return greeter_compositor_background_utils_dummy_offscreen_effect_type_id__once;
}

GreeterCompositorBackgroundUtilsColorInformation*
greeter_compositor_background_utils_color_information_dup (const GreeterCompositorBackgroundUtilsColorInformation* self)
{
	GreeterCompositorBackgroundUtilsColorInformation* dup;
#line 26 "../compositor/WingpanelManager/BackgroundUtils.vala"
	dup = g_new0 (GreeterCompositorBackgroundUtilsColorInformation, 1);
#line 26 "../compositor/WingpanelManager/BackgroundUtils.vala"
	memcpy (dup, self, sizeof (GreeterCompositorBackgroundUtilsColorInformation));
#line 26 "../compositor/WingpanelManager/BackgroundUtils.vala"
	return dup;
#line 334 "BackgroundUtils.c"
}

void
greeter_compositor_background_utils_color_information_free (GreeterCompositorBackgroundUtilsColorInformation* self)
{
#line 26 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_free (self);
#line 342 "BackgroundUtils.c"
}

static GType
greeter_compositor_background_utils_color_information_get_type_once (void)
{
	GType greeter_compositor_background_utils_color_information_type_id;
	greeter_compositor_background_utils_color_information_type_id = g_boxed_type_register_static ("GreeterCompositorBackgroundUtilsColorInformation", (GBoxedCopyFunc) greeter_compositor_background_utils_color_information_dup, (GBoxedFreeFunc) greeter_compositor_background_utils_color_information_free);
	return greeter_compositor_background_utils_color_information_type_id;
}

GType
greeter_compositor_background_utils_color_information_get_type (void)
{
	static volatile gsize greeter_compositor_background_utils_color_information_type_id__once = 0;
	if (g_once_init_enter (&greeter_compositor_background_utils_color_information_type_id__once)) {
		GType greeter_compositor_background_utils_color_information_type_id;
		greeter_compositor_background_utils_color_information_type_id = greeter_compositor_background_utils_color_information_get_type_once ();
		g_once_init_leave (&greeter_compositor_background_utils_color_information_type_id__once, greeter_compositor_background_utils_color_information_type_id);
	}
	return greeter_compositor_background_utils_color_information_type_id__once;
}

static void
greeter_compositor_background_utils_get_background_color_information_data_free (gpointer _data)
{
	GreeterCompositorBackgroundUtilsGetBackgroundColorInformationData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->wm);
	g_slice_free (GreeterCompositorBackgroundUtilsGetBackgroundColorInformationData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
greeter_compositor_background_utils_get_background_color_information (GreeterCompositorWindowManager* wm,
                                                                      gint reference_x,
                                                                      gint reference_y,
                                                                      gint reference_width,
                                                                      gint reference_height,
                                                                      GAsyncReadyCallback _callback_,
                                                                      gpointer _user_data_)
{
	GreeterCompositorBackgroundUtilsGetBackgroundColorInformationData* _data_;
	GreeterCompositorWindowManager* _tmp0_;
	g_return_if_fail (wm != NULL);
	_data_ = g_slice_new0 (GreeterCompositorBackgroundUtilsGetBackgroundColorInformationData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, greeter_compositor_background_utils_get_background_color_information_data_free);
	_tmp0_ = _g_object_ref0 (wm);
	_g_object_unref0 (_data_->wm);
	_data_->wm = _tmp0_;
	_data_->reference_x = reference_x;
	_data_->reference_y = reference_y;
	_data_->reference_width = reference_width;
	_data_->reference_height = reference_height;
	greeter_compositor_background_utils_get_background_color_information_co (_data_);
}

void
greeter_compositor_background_utils_get_background_color_information_finish (GAsyncResult* _res_,
                                                                             GreeterCompositorBackgroundUtilsColorInformation* result,
                                                                             GError** error)
{
	GreeterCompositorBackgroundUtilsGetBackgroundColorInformationData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
	*result = _data_->result;
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
	return _data16_;
#line 425 "BackgroundUtils.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_g_object_unref0 (_data16_->effect);
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
		g_slice_free (Block16Data, _data16_);
#line 439 "BackgroundUtils.c"
	}
}

static void
__lambda39_ (Block16Data* _data16_)
{
	GreeterCompositorBackgroundUtilsDummyOffscreenEffect* _tmp0_;
	MetaBackgroundActor* _tmp1_;
	GreeterCompositorBackgroundUtilsDummyOffscreenEffect* _tmp2_;
	CoglTexture* texture = NULL;
	GreeterCompositorBackgroundUtilsDummyOffscreenEffect* _tmp3_;
	CoglTexture* _tmp4_;
	CoglTexture* _tmp5_;
	guint texture_width = 0U;
	CoglTexture* _tmp6_;
	guint texture_height = 0U;
	CoglTexture* _tmp7_;
	guint8* pixels = NULL;
	guint8* _tmp8_;
	gint pixels_length1;
	gint _pixels_size_;
	gdouble* pixel_lums = NULL;
	gdouble* _tmp9_;
	gint pixel_lums_length1;
	gint _pixel_lums_size_;
	CoglTexture* _tmp10_;
	guint8* _tmp11_;
	gint _tmp11__length1;
	gint size = 0;
	gdouble mean_squares = 0.0;
	gdouble pixel = 0.0;
	gdouble max = 0.0;
	gdouble min = 0.0;
	gdouble score = 0.0;
	gdouble delta = 0.0;
	gdouble score_total = 0.0;
	gdouble r_total2 = 0.0;
	gdouble g_total2 = 0.0;
	gdouble b_total2 = 0.0;
	gdouble max_val = 0.0;
#line 80 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp0_ = _data16_->effect;
#line 80 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_signal_handler_disconnect (_tmp0_, _data16_->paint_signal_handler);
#line 81 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp1_ = _data16_->newest_background_actor;
#line 81 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp2_ = _data16_->effect;
#line 81 "../compositor/WingpanelManager/BackgroundUtils.vala"
	clutter_actor_remove_effect ((ClutterActor*) _tmp1_, (ClutterEffect*) _tmp2_);
#line 83 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp3_ = _data16_->effect;
#line 83 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp4_ = clutter_offscreen_effect_get_texture ((ClutterOffscreenEffect*) _tmp3_);
#line 83 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, cogl_texture_get_type (), CoglTexture));
#line 83 "../compositor/WingpanelManager/BackgroundUtils.vala"
	texture = _tmp5_;
#line 84 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp6_ = texture;
#line 84 "../compositor/WingpanelManager/BackgroundUtils.vala"
	texture_width = cogl_texture_get_width (_tmp6_);
#line 85 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp7_ = texture;
#line 85 "../compositor/WingpanelManager/BackgroundUtils.vala"
	texture_height = cogl_texture_get_height (_tmp7_);
#line 87 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp8_ = g_new0 (guint8, (texture_width * texture_height) * 4);
#line 87 "../compositor/WingpanelManager/BackgroundUtils.vala"
	pixels = _tmp8_;
#line 87 "../compositor/WingpanelManager/BackgroundUtils.vala"
	pixels_length1 = (texture_width * texture_height) * 4;
#line 87 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_pixels_size_ = pixels_length1;
#line 88 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp9_ = g_new0 (gdouble, texture_width * texture_height);
#line 88 "../compositor/WingpanelManager/BackgroundUtils.vala"
	pixel_lums = _tmp9_;
#line 88 "../compositor/WingpanelManager/BackgroundUtils.vala"
	pixel_lums_length1 = texture_width * texture_height;
#line 88 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_pixel_lums_size_ = pixel_lums_length1;
#line 90 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp10_ = texture;
#line 90 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp11_ = pixels;
#line 90 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_tmp11__length1 = pixels_length1;
#line 90 "../compositor/WingpanelManager/BackgroundUtils.vala"
	cogl_texture_get_data (_tmp10_, COGL_PIXEL_FORMAT_BGRA_8888_PRE, (guint) 0, _tmp11_);
#line 92 "../compositor/WingpanelManager/BackgroundUtils.vala"
	size = _data16_->width * _data16_->height;
#line 94 "../compositor/WingpanelManager/BackgroundUtils.vala"
	mean_squares = (gdouble) 0;
#line 95 "../compositor/WingpanelManager/BackgroundUtils.vala"
	pixel = (gdouble) 0;
#line 97 "../compositor/WingpanelManager/BackgroundUtils.vala"
	score_total = (gdouble) 0;
#line 97 "../compositor/WingpanelManager/BackgroundUtils.vala"
	r_total2 = (gdouble) 0;
#line 97 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_total2 = (gdouble) 0;
#line 97 "../compositor/WingpanelManager/BackgroundUtils.vala"
	b_total2 = (gdouble) 0;
#line 544 "BackgroundUtils.c"
	{
		gint y = 0;
#line 104 "../compositor/WingpanelManager/BackgroundUtils.vala"
		y = _data16_->y_start;
#line 549 "BackgroundUtils.c"
		{
			gboolean _tmp12_ = FALSE;
#line 104 "../compositor/WingpanelManager/BackgroundUtils.vala"
			_tmp12_ = TRUE;
#line 104 "../compositor/WingpanelManager/BackgroundUtils.vala"
			while (TRUE) {
#line 104 "../compositor/WingpanelManager/BackgroundUtils.vala"
				if (!_tmp12_) {
#line 558 "BackgroundUtils.c"
					gint _tmp13_;
#line 104 "../compositor/WingpanelManager/BackgroundUtils.vala"
					_tmp13_ = y;
#line 104 "../compositor/WingpanelManager/BackgroundUtils.vala"
					y = _tmp13_ + 1;
#line 564 "BackgroundUtils.c"
				}
#line 104 "../compositor/WingpanelManager/BackgroundUtils.vala"
				_tmp12_ = FALSE;
#line 104 "../compositor/WingpanelManager/BackgroundUtils.vala"
				if (!(y < (_data16_->y_start + _data16_->height))) {
#line 104 "../compositor/WingpanelManager/BackgroundUtils.vala"
					break;
#line 572 "BackgroundUtils.c"
				}
				{
					gint x = 0;
#line 105 "../compositor/WingpanelManager/BackgroundUtils.vala"
					x = _data16_->x_start;
#line 578 "BackgroundUtils.c"
					{
						gboolean _tmp14_ = FALSE;
#line 105 "../compositor/WingpanelManager/BackgroundUtils.vala"
						_tmp14_ = TRUE;
#line 105 "../compositor/WingpanelManager/BackgroundUtils.vala"
						while (TRUE) {
#line 585 "BackgroundUtils.c"
							gint i = 0;
							guint8 b = 0U;
							guint8* _tmp16_;
							gint _tmp16__length1;
							guint8 _tmp17_;
							guint8 g = 0U;
							guint8* _tmp18_;
							gint _tmp18__length1;
							guint8 _tmp19_;
							guint8 r = 0U;
							guint8* _tmp20_;
							gint _tmp20__length1;
							guint8 _tmp21_;
							gdouble* _tmp22_;
							gint _tmp22__length1;
							gdouble _tmp23_ = 0.0;
#line 105 "../compositor/WingpanelManager/BackgroundUtils.vala"
							if (!_tmp14_) {
#line 604 "BackgroundUtils.c"
								gint _tmp15_;
#line 105 "../compositor/WingpanelManager/BackgroundUtils.vala"
								_tmp15_ = x;
#line 105 "../compositor/WingpanelManager/BackgroundUtils.vala"
								x = _tmp15_ + 1;
#line 610 "BackgroundUtils.c"
							}
#line 105 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp14_ = FALSE;
#line 105 "../compositor/WingpanelManager/BackgroundUtils.vala"
							if (!(x < (_data16_->x_start + _data16_->width))) {
#line 105 "../compositor/WingpanelManager/BackgroundUtils.vala"
								break;
#line 618 "BackgroundUtils.c"
							}
#line 106 "../compositor/WingpanelManager/BackgroundUtils.vala"
							i = ((y * ((gint) texture_width)) * 4) + (x * 4);
#line 108 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp16_ = pixels;
#line 108 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp16__length1 = pixels_length1;
#line 108 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp17_ = _tmp16_[i];
#line 108 "../compositor/WingpanelManager/BackgroundUtils.vala"
							b = _tmp17_;
#line 109 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp18_ = pixels;
#line 109 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp18__length1 = pixels_length1;
#line 109 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp19_ = _tmp18_[i + 1];
#line 109 "../compositor/WingpanelManager/BackgroundUtils.vala"
							g = _tmp19_;
#line 110 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp20_ = pixels;
#line 110 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp20__length1 = pixels_length1;
#line 110 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp21_ = _tmp20_[i + 2];
#line 110 "../compositor/WingpanelManager/BackgroundUtils.vala"
							r = _tmp21_;
#line 112 "../compositor/WingpanelManager/BackgroundUtils.vala"
							pixel = ((0.3 * r) + (0.59 * g)) + (0.11 * b);
#line 114 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp22_ = pixel_lums;
#line 114 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp22__length1 = pixel_lums_length1;
#line 114 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp22_[(y * _data16_->width) + x] = pixel;
#line 116 "../compositor/WingpanelManager/BackgroundUtils.vala"
							min = (gdouble) MIN (r, MIN (g, b));
#line 117 "../compositor/WingpanelManager/BackgroundUtils.vala"
							max = (gdouble) MAX (r, MAX (g, b));
#line 119 "../compositor/WingpanelManager/BackgroundUtils.vala"
							delta = max - min;
#line 122 "../compositor/WingpanelManager/BackgroundUtils.vala"
							if (delta == ((gdouble) 0)) {
#line 122 "../compositor/WingpanelManager/BackgroundUtils.vala"
								_tmp23_ = 0.0;
#line 664 "BackgroundUtils.c"
							} else {
#line 122 "../compositor/WingpanelManager/BackgroundUtils.vala"
								_tmp23_ = delta / max;
#line 668 "BackgroundUtils.c"
							}
#line 122 "../compositor/WingpanelManager/BackgroundUtils.vala"
							score = GREETER_COMPOSITOR_BACKGROUND_UTILS_SATURATION_WEIGHT * _tmp23_;
#line 124 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_data16_->r_total += score * r;
#line 125 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_data16_->g_total += score * g;
#line 126 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_data16_->b_total += score * b;
#line 127 "../compositor/WingpanelManager/BackgroundUtils.vala"
							score_total += score;
#line 129 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_data16_->r_total += (gdouble) r;
#line 130 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_data16_->g_total += (gdouble) g;
#line 131 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_data16_->b_total += (gdouble) b;
#line 133 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_data16_->mean += pixel;
#line 134 "../compositor/WingpanelManager/BackgroundUtils.vala"
							mean_squares += pixel * pixel;
#line 690 "BackgroundUtils.c"
						}
					}
				}
			}
		}
	}
	{
		gint y = 0;
#line 138 "../compositor/WingpanelManager/BackgroundUtils.vala"
		y = _data16_->y_start + 1;
#line 701 "BackgroundUtils.c"
		{
			gboolean _tmp24_ = FALSE;
#line 138 "../compositor/WingpanelManager/BackgroundUtils.vala"
			_tmp24_ = TRUE;
#line 138 "../compositor/WingpanelManager/BackgroundUtils.vala"
			while (TRUE) {
#line 138 "../compositor/WingpanelManager/BackgroundUtils.vala"
				if (!_tmp24_) {
#line 710 "BackgroundUtils.c"
					gint _tmp25_;
#line 138 "../compositor/WingpanelManager/BackgroundUtils.vala"
					_tmp25_ = y;
#line 138 "../compositor/WingpanelManager/BackgroundUtils.vala"
					y = _tmp25_ + 1;
#line 716 "BackgroundUtils.c"
				}
#line 138 "../compositor/WingpanelManager/BackgroundUtils.vala"
				_tmp24_ = FALSE;
#line 138 "../compositor/WingpanelManager/BackgroundUtils.vala"
				if (!(y < ((_data16_->y_start + _data16_->height) - 1))) {
#line 138 "../compositor/WingpanelManager/BackgroundUtils.vala"
					break;
#line 724 "BackgroundUtils.c"
				}
				{
					gint x = 0;
#line 139 "../compositor/WingpanelManager/BackgroundUtils.vala"
					x = _data16_->x_start + 1;
#line 730 "BackgroundUtils.c"
					{
						gboolean _tmp26_ = FALSE;
#line 139 "../compositor/WingpanelManager/BackgroundUtils.vala"
						_tmp26_ = TRUE;
#line 139 "../compositor/WingpanelManager/BackgroundUtils.vala"
						while (TRUE) {
#line 737 "BackgroundUtils.c"
							gdouble acutance = 0.0;
							gdouble* _tmp28_;
							gint _tmp28__length1;
							gdouble _tmp29_;
							gdouble* _tmp30_;
							gint _tmp30__length1;
							gdouble _tmp31_;
							gdouble* _tmp32_;
							gint _tmp32__length1;
							gdouble _tmp33_;
							gdouble* _tmp34_;
							gint _tmp34__length1;
							gdouble _tmp35_;
							gdouble* _tmp36_;
							gint _tmp36__length1;
							gdouble _tmp37_;
							gdouble _tmp38_ = 0.0;
#line 139 "../compositor/WingpanelManager/BackgroundUtils.vala"
							if (!_tmp26_) {
#line 757 "BackgroundUtils.c"
								gint _tmp27_;
#line 139 "../compositor/WingpanelManager/BackgroundUtils.vala"
								_tmp27_ = x;
#line 139 "../compositor/WingpanelManager/BackgroundUtils.vala"
								x = _tmp27_ + 1;
#line 763 "BackgroundUtils.c"
							}
#line 139 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp26_ = FALSE;
#line 139 "../compositor/WingpanelManager/BackgroundUtils.vala"
							if (!(x < ((_data16_->x_start + _data16_->width) - 1))) {
#line 139 "../compositor/WingpanelManager/BackgroundUtils.vala"
								break;
#line 771 "BackgroundUtils.c"
							}
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp28_ = pixel_lums;
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp28__length1 = pixel_lums_length1;
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp29_ = _tmp28_[(y * _data16_->width) + x];
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp30_ = pixel_lums;
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp30__length1 = pixel_lums_length1;
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp31_ = _tmp30_[((y * _data16_->width) + x) - 1];
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp32_ = pixel_lums;
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp32__length1 = pixel_lums_length1;
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp33_ = _tmp32_[((y * _data16_->width) + x) + 1];
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp34_ = pixel_lums;
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp34__length1 = pixel_lums_length1;
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp35_ = _tmp34_[((y - 1) * _data16_->width) + x];
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp36_ = pixel_lums;
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp36__length1 = pixel_lums_length1;
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_tmp37_ = _tmp36_[((y + 1) * _data16_->width) + x];
#line 140 "../compositor/WingpanelManager/BackgroundUtils.vala"
							acutance = (_tmp29_ * 4) - (((_tmp31_ + _tmp33_) + _tmp35_) + _tmp37_);
#line 149 "../compositor/WingpanelManager/BackgroundUtils.vala"
							if (acutance > ((gdouble) 0)) {
#line 149 "../compositor/WingpanelManager/BackgroundUtils.vala"
								_tmp38_ = acutance;
#line 809 "BackgroundUtils.c"
							} else {
#line 149 "../compositor/WingpanelManager/BackgroundUtils.vala"
								_tmp38_ = -acutance;
#line 813 "BackgroundUtils.c"
							}
#line 149 "../compositor/WingpanelManager/BackgroundUtils.vala"
							_data16_->mean_acutance += _tmp38_;
#line 817 "BackgroundUtils.c"
						}
					}
				}
			}
		}
	}
#line 153 "../compositor/WingpanelManager/BackgroundUtils.vala"
	score_total /= (gdouble) size;
#line 154 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data16_->b_total /= (gdouble) size;
#line 155 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data16_->g_total /= (gdouble) size;
#line 156 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data16_->r_total /= (gdouble) size;
#line 158 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (score_total > 0.0) {
#line 159 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data16_->b_total /= score_total;
#line 160 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data16_->g_total /= score_total;
#line 161 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data16_->r_total /= score_total;
#line 840 "BackgroundUtils.c"
	}
#line 164 "../compositor/WingpanelManager/BackgroundUtils.vala"
	b_total2 /= (gdouble) (size * G_MAXUINT8);
#line 165 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_total2 /= (gdouble) (size * G_MAXUINT8);
#line 166 "../compositor/WingpanelManager/BackgroundUtils.vala"
	r_total2 /= (gdouble) (size * G_MAXUINT8);
#line 173 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (score_total <= GREETER_COMPOSITOR_BACKGROUND_UTILS_WEIGHT_THRESHOLD) {
#line 850 "BackgroundUtils.c"
		gdouble f = 0.0;
		gdouble rf = 0.0;
#line 174 "../compositor/WingpanelManager/BackgroundUtils.vala"
		f = (1.0 / GREETER_COMPOSITOR_BACKGROUND_UTILS_WEIGHT_THRESHOLD) * score_total;
#line 175 "../compositor/WingpanelManager/BackgroundUtils.vala"
		rf = 1.0 - f;
#line 177 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data16_->b_total = (_data16_->b_total * f) + (b_total2 * rf);
#line 178 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data16_->g_total = (_data16_->g_total * f) + (g_total2 * rf);
#line 179 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data16_->r_total = (_data16_->r_total * f) + (r_total2 * rf);
#line 863 "BackgroundUtils.c"
	}
#line 183 "../compositor/WingpanelManager/BackgroundUtils.vala"
	max_val = MAX (_data16_->r_total, MAX (_data16_->g_total, _data16_->b_total));
#line 185 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (max_val > 1.0) {
#line 186 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data16_->b_total /= max_val;
#line 187 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data16_->g_total /= max_val;
#line 188 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data16_->r_total /= max_val;
#line 875 "BackgroundUtils.c"
	}
#line 191 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data16_->mean /= (gdouble) size;
#line 192 "../compositor/WingpanelManager/BackgroundUtils.vala"
	mean_squares = mean_squares / size;
#line 194 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data16_->variance = mean_squares - (_data16_->mean * _data16_->mean);
#line 196 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data16_->mean_acutance /= (gdouble) ((_data16_->width - 2) * (_data16_->height - 2));
#line 198 "../compositor/WingpanelManager/BackgroundUtils.vala"
	greeter_compositor_background_utils_get_background_color_information_co (_data16_->_async_data_);
#line 79 "../compositor/WingpanelManager/BackgroundUtils.vala"
	pixel_lums = (g_free (pixel_lums), NULL);
#line 79 "../compositor/WingpanelManager/BackgroundUtils.vala"
	pixels = (g_free (pixels), NULL);
#line 79 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_g_object_unref0 (texture);
#line 893 "BackgroundUtils.c"
}

static void
___lambda39__greeter_compositor_background_utils_dummy_offscreen_effect_done_painting (GreeterCompositorBackgroundUtilsDummyOffscreenEffect* _sender,
                                                                                       gpointer self)
{
#line 79 "../compositor/WingpanelManager/BackgroundUtils.vala"
	__lambda39_ (self);
#line 902 "BackgroundUtils.c"
}

static gboolean
greeter_compositor_background_utils_get_background_color_information_co (GreeterCompositorBackgroundUtilsGetBackgroundColorInformationData* _data_)
{
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
	switch (_data_->_state_) {
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
		case 0:
#line 912 "BackgroundUtils.c"
		goto _state_0;
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
		case 1:
#line 916 "BackgroundUtils.c"
		goto _state_1;
		default:
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
		g_assert_not_reached ();
#line 921 "BackgroundUtils.c"
	}
	_state_0:
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_ = g_slice_new0 (Block16Data);
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->_ref_count_ = 1;
#line 35 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->_async_data_ = _data_;
#line 37 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp0_ = greeter_compositor_window_manager_get_background_group (_data_->wm);
#line 37 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 37 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp2_ = meta_plugin_get_display ((MetaPlugin*) _data_->wm);
#line 37 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp3_ = clutter_actor_get_child_at_index ((ClutterActor*) _data_->_tmp1_, meta_display_get_primary_monitor (_data_->_tmp2_));
#line 37 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GREETER_COMPOSITOR_TYPE_BACKGROUND_MANAGER, GreeterCompositorBackgroundManager));
#line 37 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->bg_manager = _data_->_tmp4_;
#line 39 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp5_ = _data_->bg_manager;
#line 39 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (_data_->_tmp5_ == NULL) {
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp6_ = meta_plugin_get_display ((MetaPlugin*) _data_->wm);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp7_ = g_strdup_printf ("Invalid monitor requested: %i", meta_display_get_primary_monitor (_data_->_tmp6_));
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp9_ = g_error_new_literal (G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, _data_->_tmp8_);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_g_free0 (_data_->_tmp8_);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_inner_error0_ = _data_->_tmp10_;
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
		if (_data_->_inner_error0_->domain == G_DBUS_ERROR) {
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			_g_object_unref0 (_data_->bg_manager);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			block16_data_unref (_data_->_data16_);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			_data_->_data16_ = NULL;
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_object_unref (_data_->_async_result);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			return FALSE;
#line 974 "BackgroundUtils.c"
		} else {
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			_g_object_unref0 (_data_->bg_manager);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			block16_data_unref (_data_->_data16_);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			_data_->_data16_ = NULL;
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_object_unref (_data_->_async_result);
#line 40 "../compositor/WingpanelManager/BackgroundUtils.vala"
			return FALSE;
#line 990 "BackgroundUtils.c"
		}
	}
#line 43 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp11_ = greeter_compositor_background_utils_dummy_offscreen_effect_new ();
#line 43 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_object_ref_sink (_data_->_tmp11_);
#line 43 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->effect = _data_->_tmp11_;
#line 44 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp12_ = _data_->bg_manager;
#line 44 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp13_ = greeter_compositor_background_manager_get_newest_background_actor (_data_->_tmp12_);
#line 44 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 44 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->newest_background_actor = _data_->_tmp14_;
#line 45 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp15_ = _data_->_data16_->newest_background_actor;
#line 45 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp16_ = _data_->_data16_->effect;
#line 45 "../compositor/WingpanelManager/BackgroundUtils.vala"
	clutter_actor_add_effect ((ClutterActor*) _data_->_tmp15_, (ClutterEffect*) _data_->_tmp16_);
#line 47 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp17_ = _data_->_data16_->newest_background_actor;
#line 47 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp18_ = clutter_actor_get_width ((ClutterActor*) _data_->_tmp17_);
#line 47 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 47 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->bg_actor_width = (gint) _data_->_tmp19_;
#line 48 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp20_ = _data_->_data16_->newest_background_actor;
#line 48 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp21_ = clutter_actor_get_height ((ClutterActor*) _data_->_tmp20_);
#line 48 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 48 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->bg_actor_height = (gint) _data_->_tmp22_;
#line 55 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->x_start = _data_->reference_x;
#line 56 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (_data_->_data16_->x_start < 2) {
#line 57 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_data16_->x_start = 2;
#line 1035 "BackgroundUtils.c"
	}
#line 60 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->y_start = _data_->reference_y;
#line 61 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (_data_->_data16_->y_start < 2) {
#line 62 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_data16_->y_start = 2;
#line 1043 "BackgroundUtils.c"
	}
#line 69 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->width = MIN ((_data_->bg_actor_width - 2) - _data_->reference_x, _data_->reference_width);
#line 70 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->height = MIN ((_data_->bg_actor_height - 2) - _data_->reference_y, _data_->reference_height);
#line 72 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (_data_->_data16_->x_start > _data_->bg_actor_width) {
#line 72 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp25_ = TRUE;
#line 1053 "BackgroundUtils.c"
	} else {
#line 72 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp25_ = _data_->_data16_->y_start > _data_->bg_actor_height;
#line 1057 "BackgroundUtils.c"
	}
#line 72 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (_data_->_tmp25_) {
#line 72 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp24_ = TRUE;
#line 1063 "BackgroundUtils.c"
	} else {
#line 72 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp24_ = _data_->_data16_->width <= 0;
#line 1067 "BackgroundUtils.c"
	}
#line 72 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (_data_->_tmp24_) {
#line 72 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp23_ = TRUE;
#line 1073 "BackgroundUtils.c"
	} else {
#line 72 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp23_ = _data_->_data16_->height <= 0;
#line 1077 "BackgroundUtils.c"
	}
#line 72 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (_data_->_tmp23_) {
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp26_ = g_strdup_printf ("Invalid rectangle specified: %i, %i, %i, %i", _data_->_data16_->x_start, _data_->_data16_->y_start, _data_->_data16_->width, _data_->_data16_->height);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp27_ = _data_->_tmp26_;
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp28_ = g_error_new_literal (G_DBUS_ERROR, G_DBUS_ERROR_INVALID_ARGS, _data_->_tmp27_);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_tmp29_ = _data_->_tmp28_;
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_g_free0 (_data_->_tmp27_);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
		_data_->_inner_error0_ = _data_->_tmp29_;
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
		if (_data_->_inner_error0_->domain == G_DBUS_ERROR) {
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			_g_object_unref0 (_data_->bg_manager);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			block16_data_unref (_data_->_data16_);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			_data_->_data16_ = NULL;
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_object_unref (_data_->_async_result);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			return FALSE;
#line 1107 "BackgroundUtils.c"
		} else {
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			_g_object_unref0 (_data_->bg_manager);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			block16_data_unref (_data_->_data16_);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			_data_->_data16_ = NULL;
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_object_unref (_data_->_async_result);
#line 73 "../compositor/WingpanelManager/BackgroundUtils.vala"
			return FALSE;
#line 1123 "BackgroundUtils.c"
		}
	}
#line 76 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->mean_acutance = (gdouble) 0;
#line 76 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->variance = (gdouble) 0;
#line 76 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->mean = (gdouble) 0;
#line 76 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->r_total = (gdouble) 0;
#line 76 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->g_total = (gdouble) 0;
#line 76 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->b_total = (gdouble) 0;
#line 77 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->paint_signal_handler = (gulong) 0;
#line 79 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp30_ = _data_->_data16_->effect;
#line 79 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp31_ = g_signal_connect_data (_data_->_tmp30_, "done-painting", (GCallback) ___lambda39__greeter_compositor_background_utils_dummy_offscreen_effect_done_painting, block16_data_ref (_data_->_data16_), (GClosureNotify) block16_data_unref, 0);
#line 79 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_->paint_signal_handler = _data_->_tmp31_;
#line 201 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp32_ = _data_->_data16_->newest_background_actor;
#line 201 "../compositor/WingpanelManager/BackgroundUtils.vala"
	clutter_actor_queue_redraw ((ClutterActor*) _data_->_tmp32_);
#line 203 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_state_ = 1;
#line 203 "../compositor/WingpanelManager/BackgroundUtils.vala"
	return FALSE;
#line 1154 "BackgroundUtils.c"
	_state_1:
	;
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	memset (&_data_->_tmp33_, 0, sizeof (GreeterCompositorBackgroundUtilsColorInformation));
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp33_.average_red = _data_->_data16_->r_total;
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp33_.average_green = _data_->_data16_->g_total;
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp33_.average_blue = _data_->_data16_->b_total;
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp33_.mean_luminance = _data_->_data16_->mean;
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp33_.luminance_variance = _data_->_data16_->variance;
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_tmp33_.mean_acutance = _data_->_data16_->mean_acutance;
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->result = _data_->_tmp33_;
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_g_object_unref0 (_data_->bg_manager);
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	block16_data_unref (_data_->_data16_);
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	_data_->_data16_ = NULL;
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	if (_data_->_state_ != 0) {
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1187 "BackgroundUtils.c"
		}
	}
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	g_object_unref (_data_->_async_result);
#line 205 "../compositor/WingpanelManager/BackgroundUtils.vala"
	return FALSE;
#line 1194 "BackgroundUtils.c"
}

